//--------------------------------------------//
//	􉽃IuWFNg`(ɃfobNp)
//	
//	쐬ҁFDaiki Terai
//	쐬F2010/01/03
//	CF
//--------------------------------------------//

#ifndef _GEOMETORY_H_
#define _GEOMETORY_H_

#include "direct3d9.h"
#include "effect.h"
#include "object3d.h"
#include <vector>

// 􉽃IuWFNgNX
class Geometory 
{
private:
	// 2_\
	struct Vtx2D{
		float	x,y,z;
		float	rhw;
		int		color;
	};
	// 3_\
	struct Vtx3D{
		float	x,y,z;
		int		color;
	};

	// `pX
	enum {
		PASS_DRAW2D,
		PASS_DRAW3D
	};


	static Effect						m_Effect;		// 􉽃IuWFNgGtFNg
	static IDirect3DVertexDeclaration9*	m_pVertexDecl2D;// 2􉽃IuWFNg_\̐錾
	static IDirect3DVertexDeclaration9*	m_pVertexDecl3D;// 3􉽃IuWFNg_\̐錾
	
	// RXgN^
	Geometory(){}
	// Rs[RXgN^
	Geometory(const Geometory& obj){}
	// Zq
	Geometory& operator=(const Geometory& obj){}

public:
	// 
	static bool Init(IDirect3DDevice9* pD3DDevice);
	// 
	static void Release();

	//////////////////////////////////////////////////////////////////////////////////////////
	//								2IuWFNg`										//
	//////////////////////////////////////////////////////////////////////////////////////////


	//-------------------------------------------//
	//	`
	//
	//	F	Start		n_
	//			End			I_
	//			Color		F
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//-------------------------------------------//
	static bool DrawLine(const D3DXVECTOR2& Start,const D3DXVECTOR2& End,DWORD Color = 0xffff0000);

	//-------------------------------------------//
	//	ې`
	//
	//	F	R		a
	//			Pos		ʒu
	//			Color	F
	//			
	//	߂lF	true:	`搬
	//			false:	`掸s
	//-------------------------------------------//
	static bool DrawCircle(float R,const D3DXVECTOR2& Pos,DWORD Color = 0xffff0000);

	//-------------------------------------------//
	//	ە`
	//
	//	F	R		a
	//			Pos		ʒu
	//			Color	F
	//			
	//	߂lF	true:	`搬
	//			false:	`掸s
	//-------------------------------------------//
	static bool DrawFillCircle(float R,const D3DXVECTOR2& Pos,DWORD Color = 0xffff0000);

	//-------------------------------------------//
	//	``
	//
	//	F	Rect		`
	//			Color		F
	//
	//	߂lFtrue:	`搬
	//			false:	`掸s
	//-------------------------------------------//
	static bool DrawRect(const RECT& Rect,DWORD Color = 0xffff0000);

	//-------------------------------------------//
	//	``
	//
	//	F	Rect		`
	//			Color		F
	//
	//	߂lFtrue:	`搬
	//			false:	`掸s
	//-------------------------------------------//
	static bool DrawFillRect(const RECT& Rect,DWORD Color = 0xffff0000);

	//////////////////////////////////////////////////////////////////////////////////////////
	//								3IuWFNg`										//
	//////////////////////////////////////////////////////////////////////////////////////////

private:
	//------------------------------------------//
	//	GtFNgɕϊsZbg
	//	
	//		F	pWorldMtx	[hϊs
	//
	//	߂lF	true:	Zbg
	//			false:	Zbgs
	//------------------------------------------//
	static bool SetEffectParam(const D3DXMATRIX* pWorldMtx);

public:

	//-----------------------------------------------
	//	Obh`
	//
	//	F	Wide		
	//			Divide		
	//			pWorldMtx	[hϊs
	//			Color		F
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawGrid(float Wide,int Divide = 5,const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffffffff);

	//-----------------------------------------------
	//	3`
	//
	//	F	Length		̒
	//			pWorldMtx	[hϊs
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawAxis(float Length,const D3DXMATRIX* pWorldMtx = NULL);

	//-----------------------------------------------
	//	`
	//
	//	F	Start		n_
	//			End			I_
	//			pWorldMtx	[hϊs
	//			Color		F
	//
	//	߂lFtrue:	`搬
	//			false:	`掸s
	//-----------------------------------------------
	static bool DrawLine(const D3DXVECTOR3& Start,const D3DXVECTOR3& End,const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000);

	//--------------------------------------------
	//	Op``
	//
	//	F	Vtx			Op`̒_
	//			pWorldMtx	[hϊs
	//			Color		F
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawTriangle(const D3DXVECTOR3 Vtx[3],const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000);

	//--------------------------------------------
	//	Op``
	//
	//	F	Vtx			Op`̒_
	//			pWorldMtx	[hϊs
	//			Color		F
	//
	//	߂lFtrue:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawFillTriangle(const D3DXVECTOR3 Vtx[3],const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000);


	//--------------------------------------------
	//	̐`
	//
	//	F	pWorldMtx	[hϊs
	//			Color		F
	//			Min			̂̑Ίpŏ_
	//			Max			̂̑Ίpő_
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawCube(const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000,const D3DXVECTOR3 &Min = D3DXVECTOR3(-0.5f,-0.5f,-0.5f),const D3DXVECTOR3 &Max = D3DXVECTOR3(0.5f,0.5f,0.5f));

	//-----------------------------------------------
	//	`
	//
	//	F	pWorldMtx	[hϊs
	//			Color		F
	//			Pos			̒SW
	//			R			̔a			
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawSphere(const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000,const D3DXVECTOR3 &Pos = D3DXVECTOR3(0.0f,0.0f,0.0f),float R = 1.0f);

	//---------------------------------------------
	//	JvZ`
	//
	//	F	pWorldMtx	[hϊs
	//			Color		F
	//			R			̔a			
	//			Height		~̍
	//
	//	߂lF	true:	`搬
	//			false:	`掸s
	//--------------------------------------------
	static bool DrawCapsule(const D3DXMATRIX* pWorldMtx = NULL,DWORD Color = 0xffff0000,float R = 1.0f,float Height = 2.0f);
};

#endif