//------------------------------------------------------//
//	DirectShow											//
//	PlatformSDK̃CXg[Kv						//
//	FWindowsXPŃfobNNƗ(s)	//	
//														//
//	쐬		Daiki Terai								//
//	쐬		2010/10/01								//
//	C	2011/08/04								//
//------------------------------------------------------//

#ifndef	_DIRECTSHOW_H_
#define	_DIRECTSHOW_H_

#include "safefree.hpp"
#include "debug.hpp"
#include <comdef.h>
#include <tchar.h>
#include <crtdbg.h>


// t@CĐƂ
// 炩ߍĐł邩iR[fbNĂ邩jmF邱


// Filter:f[^̓o͗pR|[lg
// Source Filter ͗p
// Transform Filter f[^ϊp
// Renderer Filter o͗p

// Pin:Filterڑp
// FilteŕAPinPinڑ邱Ƃɂ肻ꂼ̊֘A\z
// Filter͍ŒPPinBiATransform Filter͍ŒQj
// Pinɂ́AOutput PinInput Pin̂Q
// Output PinInput PinłP΂Pڑ

// Graph:PʃR|[lg
// DirectShowł́AFiltergݍ킹邱ƂɂGraphł
// Đ/~/ꎞ~Ȃǂ̓Graphɑ΂čs
// Graphɂ́ASource FilterRenderer FilterꂼŒP܂܂ĂȂ΂ȂȂ

// Filter Graph Manager:FilterGraph̐ڑȂǂs
// قƂǂ̊{Iȓ́AFilter Graph Manager_Ƃčs

///////////////////		/////////////////////	  //////////////////////	
//	SourceFilter //-----// TransformFilter //-----// RendererFilter	  //
///////////////////		/////////////////////	  //////////////////////

// O錾
struct IGraphBuilder;
struct IMediaControl;
struct IMediaEvent;
struct IMediaSeeking;
struct IVideoWindow;
struct IBasicVideo;

struct ICaptureGraphBuilder2;
struct ICreateDevEnum;
struct IEnumMoniker;
struct IMoniker;
struct IBaseFilter;
struct ISampleGrabber;


class DirectShow 
{
public:
	// RXgN^
	DirectShow();
	// fXgN^
	virtual ~DirectShow();
	// Ot쐬(rfI)
	// F	FileName	Đt@C
	//			hWnd		֘AÂEBhE
	bool LoadVideo(const TCHAR* FileName,HWND hWnd = NULL);
	// Ot쐬(USBJLv`[)
	// F	hWnd		֘AÂEBhE
	bool Capture(HWND hWnd = NULL);

	// 
	void Release();

	// rfIorLv`[擾
	long GetWidth();
	// rfIorLv`[擾
	long GetHeight();

	// ݂̍ĐԂ̎擾
	LONGLONG GetCurrentTime();
	// ̑Ԃ̎擾
	LONGLONG GetDuration();

	// Đ̔(^CAEg~b)
	bool IsPlaying(long TimeOut = 10);
	// ~
	bool Stop();
	// Đ(ʃXbhĐɂȂ)
	bool Play();

	// _[eNX`bN̐擪|C^nƂŃf[^擾
	// UV㉺]̂Œ
	// (eNX`tH[}bg̓rfIˑʏA8R8G8B8)
	bool GetBuffer(long* pOutBuffer = NULL);
private:
	bool					m_isPlay;				// Đ̃tO
	long					m_Width;				// rfIorLv`[
	long					m_Height;				// rfIorLv`[
	long					m_BufferSize;			// obt@TCY

	IGraphBuilder*			m_pGraphBuilder;		// tB^[Ot}l[WiOt쐬AǗpj
	IMediaControl*			m_pMediaControl;		// fBARg[(Ot̍ĐA~Rg[)
	IMediaEvent*			m_pMediaEvent;			// fBACxg
	IMediaSeeking*			m_pMediaSeeking;		// fBAV[N
	IVideoWindow*			m_pVideoWindow;			// rfIEBhEiOt\EBhEj
	IBasicVideo*			m_pBasicVideo;			// rfI
	
	ICaptureGraphBuilder2*	m_pCaptureGraphBuilder2;// rfILv`[
	ICreateDevEnum*			m_pCreateDevEnum;		// foCX
	IEnumMoniker*			m_pEnumMoniker;			// foCX
	IMoniker*				m_pMoniker;				// foCX
	IBaseFilter*			m_pDeviceFilter;		// foCXtB^[

	IBaseFilter*			m_pSampleGrabberFilter;	// TvOotB^[
	ISampleGrabber*			m_pSampleGrabber;		// TvOoiLv`[obt@擾pj
	IBaseFilter*			m_pNullFilter;			// NULL_OtB^[
	IBaseFilter*			m_pVideoFilter;			// rfI_OtB^[
};

#endif