//---------------------------------------------//
//	GtFNgNX
//
//	TvF	vOupCvCł
//			`vO(VF[_[js
//
//	쐬ҁFDaiki Terai
//	쐬F2010/08/07
//	C
//---------------------------------------------//

#ifndef _EFFECT_H_
#define _EFFECT_H_

#include "direct3d9.h"
#include <map>

class Effect
{
private:

	ID3DXEffect*											m_pEffect;			// GtFNg|C^
	std::map<std::basic_string<TCHAR>,D3DXHANDLE>			m_hTechniques;		// eNjbNnh
	std::map<std::basic_string<TCHAR>,D3DXHANDLE>			m_hParams;			// VF[_O[oϐnh
	std::map<std::basic_string<TCHAR>,D3DXTECHNIQUE_DESC>	m_Techniques;		// eNjbN
	std::map<std::basic_string<TCHAR>,D3DXPARAMETER_DESC>	m_Params;			// VF[_O[oϐ
	std::basic_string<TCHAR>								m_Name;				// GtFNg
	int														m_ID;				// GtFNg\[XID
	D3DXHANDLE												m_hCurrentTechnique;// ݂̃eNjbN
	UINT													m_CurrentPass;		// ݂̃pX

	// eNjbN擾
	void GetTechniques(); 
	// VF[_ϐ擾
	void GetParams();

public:

	// RXgN^
	Effect();
	// Rs[RXgN^
	Effect(const Effect& obj);
	// Zq̃I[o[[h
	Effect& operator=(const Effect& obj);
	// Rs[(deep copy)
	bool Clone(const Effect* pEffect);
	// fXgN^
	virtual ~Effect();
	
	// t@CGtFNg쐬
	bool Create(IDirect3DDevice9* pD3DDevice,const TCHAR* FXFileName);
	// \[XGtFNg쐬
	bool Create(IDirect3DDevice9* pD3DDevice,int ResourceID);

	// GtFNg|C^擾
	ID3DXEffect* GetEffect();
	
	// VF[_O[oϐ`FbN
	bool IsParamName(const TCHAR* ParamName);
	// sZbg
	bool SetMatrix(const TCHAR* ParamName,const D3DXMATRIX* pMtx);
	// spbgZbg
	bool SetMatrixArray(const TCHAR* ParamName,const D3DXMATRIX* pMtxArray,int Count);
	// 4xNgZbg
	bool SetVector4(const TCHAR* ParamName,const D3DXVECTOR4* pVec4);
	// 3xNgZbg
	bool SetVector3(const TCHAR* ParamName,const D3DXVECTOR3* pVec3);
	// Zbg
	bool SetFloat(const TCHAR* ParamName,float Param);
	// ̃Zbg
	bool SetInt(const TCHAR* ParamName,int Param);
	// eNX`Zbg
	bool SetTexture(const TCHAR* TextureName,IDirect3DBaseTexture9* pTexture);

	// eNjbÑZbg
	bool SetTechnique(const TCHAR* TechniqueName,UINT Pass = 0);
	// GtFNgJn
	bool Begin();
	// GtFNgI
	bool End();
};


#endif