//----------------------------------//
//	TEh(ZJ_)obt@NX
//									
//	쐬 	 Daiki Terai			
//	쐬	 2009/12/22				
//	C 2011/02/02				
//----------------------------------//

#ifndef	_SOUNDBUFFER_H_
#define	_SOUNDBUFFER_H_

#include "directsound.h"
#include "wave.h"
#include <vector>
#include <d3d9.h>
#include <d3dx9.h>


// TEhiZJ_jobt@NX
class SoundBuffer
{
private:
	IDirectSoundBuffer8*	m_pDS8SoundBuffer;	// TEhiZJ_jobt@
	IDirectSound3DBuffer8*	m_pDS8Sound3DBuffer;// 3DTEhobt@
	
public:
	// RXgN^
	SoundBuffer();
	// fXgN^
	virtual ~SoundBuffer();

	//----------------------------------------------------------------------------------
	//	TEh(ZJ_)obt@쐬	
	//
	//	F			pDirectSound8		DirectSoundIuWFNg
	//					wave				Wavef[^
	//					is3DSound			3DtOim̂݉j
	//					Guid				̃ASY
	//
	//	GUID:			DS3DALG_NO_VIRTUALIZATION	ő̃ASY
	//					DS3DALG_HRTF_LIGHT			botD悷ASY
	//					DS3DALG_HRTF_FULL			̃ASY
	//----------------------------------------------------------------------------------
	bool Create(IDirectSound8* pDirectSound8,Wave& wave,bool is3DSound = false,GUID Guid = DS3DALG_NO_VIRTUALIZATION);

	// TEhobt@(N[)쐬
	// ӁFGtFNgʃtO(DSBCAPS_CTRLFX)͕łȂ	
	bool Create(IDirectSound8* pDirectSound8,IDirectSoundBuffer8* pDS8SoundBuffer,bool is3DSound = false);

	// TEhĐ
	void Play(bool isLoop = false);
	// TEh~
	void Stop();
	// TEh~Ă邩H
	bool IsStop();
	// Đʒu擾
	DWORD GetCursorPos();
	// ---------------------------------------------------------------
	//	TEh̉ʁi{[jݒ
	//
	//	:	volume	{[î݁A̒li0`-10000jj
	// ---------------------------------------------------------------
	void SetSoundVolume(long volume);
	// -----------------------------------------------------------------------------
	//	TEh̃piEXs[J[̉ʁjݒ
	//
	//	:	Pan		p̒l(i0`10000jFEAi0`-10000jF)
	// -----------------------------------------------------------------------------
	void SetSoundPan(long Pan);

	//------------------------------------------------------------------
	//	RcTEh̃[hݒ
	//
	//			mode				DS3DMODE_NORMAL܂DS3DMODE_HEADRELATIVE܂DS3DMODE_DISABLEݒ
	//
	//			DS3DMODE_NORMAL			:́uʒuvuxvuv3DԓɂΒlƂĈ
	//			DS3DMODE_HEADRELATIVE	:́uʒuvuxvuv̓Xi[ɑ΂鑊ΒlƂĈ
	//			DS3DMODE_DISABLE		:3D𖳌
	//
	//	߂l	Ȃ
	//------------------------------------------------------------------
	void Set3DSoundMode(int mode);

	//------------------------------------------------------------------
	//	RcTEḧʒu̐ݒ
	//
	//			Pos ʒu
	//
	//	߂l	Ȃ
	//------------------------------------------------------------------
	void Set3DSoundPos(const D3DXVECTOR3& Pos);

	//------------------------------------------------------------------
	//	RcTEh̍ŏƍő勗̐ݒ
	//
	//			Min	ŏi̋𒴂Ɖ̌n܂j
	//			Max	ő勗i̋𒴂ƊSɉȂȂj
	//
	//	߂l	Ȃ
	//------------------------------------------------------------------
	void Set3DSoundDistance(float Min,float Max);

	//------------------------------------------------------------------
	//	RcTEḧʒuAAR[AOR[̐ݒ
	//
	//			Dir					TEhR[̕xNg
	//			InsideConeAngle		R[`px(ftHg360x)
	//			OutsideConeAngle	OR[`px(ftHg360x)
	//			OutsideVolume		OR[̌(ftHgȂ)
	//
	//	߂l	Ȃ
	//------------------------------------------------------------------
	void Set3DSoundCone(
		const D3DXVECTOR3& Dir = D3DXVECTOR3(0.0f,0.0f,0.0f),
		unsigned long InsideConeAngle = 360,
		unsigned long OutsideConeAngle = 360,
		long OutsideVolume = DS3D_DEFAULTCONEOUTSIDEVOLUME);

	// TEhiZJ_jobt@擾
	IDirectSoundBuffer8* GetSoundBuffer();
};


#endif