//----------------------------------//
//	Tv	Direct3D9foCX̍쐬	//
//									//
//	쐬	Daiki Terai				//
//	쐬	2009/12/18				//
//	C						//
//----------------------------------//



#ifndef _DIRECT3D9_H_
#define _DIRECT3D9_H_



#define D3D_DEBUG_INFO	// fobNtO

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
#pragma comment(lib, "d3dxof.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "winmm.lib")
/*---------------------------------------------------------------------------*/
#include <comdef.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <windows.h>
#include <mmsystem.h>

#include "safefree.hpp"
#include "unicode.hpp"
#include "debug.hpp"

// ʃwb_[
#include <string>
#include <tchar.h>
/*---------------------------------------------------------------------------*/


class Direct3D9
{
protected:	
	
	IDirect3D9*						m_D3D9;								// Direct3DfoCXpIuWFNg
	IDirect3DDevice9*				m_pDevice3D;						// Direct3D̃foCX
	D3DPRESENT_PARAMETERS			m_D3DParam;							// Xbv`FCݒ
	D3DDEVTYPE						m_DeviceType;						// foCX^Cv
	D3DDISPLAYMODE					m_Display;							// fBXvC
	D3DCAPS9						m_D3DCaps;							// `foCX̐\
	IDirect3DSurface9*				m_pBackBufferSurface;				// obNobt@T[tFX
	IDirect3DSurface9*				m_pBackBufferDepthStencilSurface;	// obNobt@[xobt@T[tFX
	D3DVIEWPORT9					m_ViewPort;							// r[|[g

public:

	//--------------------------------------------
	//	RXgN^
	//--------------------------------------------
	Direct3D9();
	//--------------------------------------------
	//	fXgN^
	//--------------------------------------------
	virtual ~Direct3D9();


	//--------------------------------------------
	//	Direct3D
	//
	//	@	hWnd		EBhEnh
	//			Width		
	//			Height		
	//			bWindowMode	EBhE[hۂ
	//			bInterval	fBXvC̓邩ۂ
	//
	//	߂l	true	
	//			false	s@
	//--------------------------------------------
	bool Create(HWND hWnd,int Width,int Height,bool bWindowMode = true,bool bInterval = true);

	//--------------------------------------------
	//	foCX̎擾
	//
	//			Ȃ
	//	
	//	߂l	direct3DfoCX
	//--------------------------------------------
	IDirect3DDevice9* GetDevice();

	//----------------------------------
	//	(_[^[Qbg)NA
	//
	//			NAF
	//
	//	߂l	true	
	//			false	s
	//----------------------------------
	bool ScreenClear(DWORD Color);

	//----------------------------------
	//	`Jn
	//
	//	߂l	true	
	//			false	s
	//----------------------------------
	bool BeginScene();

	//----------------------------------
	//	`I
	//
	//	߂l	true	
	//			false	s
	//----------------------------------
	bool EndScene();

	//----------------------------------
	//	Xbv`FC\ʂɏo
	//
	//	߂l	true	
	//			false	s
	//----------------------------------
	bool Present();

	//--------------------------------------------
	//	obNobt@T[tFCX̎擾
	//
	//		Ȃ
	//
	//	߂l	obNobt@T[tFCX
	//--------------------------------------------
	IDirect3DSurface9* GetBackBufferSurface();
	//--------------------------------------------
	//	obNobt@[xobt@T[tFCX̎擾
	//
	//		Ȃ
	//
	//	߂l	obNobt@[xobt@T[tFCX
	//--------------------------------------------
	IDirect3DSurface9* GetBackBufferDepthStencilSurface();
	//--------------------------------------------
	//	Xbv`FCݒ擾
	//
	//		Ȃ
	//
	//	߂l	Xbv`FCݒ
	//--------------------------------------------
	D3DPRESENT_PARAMETERS* GetPresentParam();
	//--------------------------------------------
	//	r[|[g̎擾
	//
	//		Ȃ
	//
	//	߂l	r[|[g
	//--------------------------------------------
	D3DVIEWPORT9* GetViewPort();


	//--------------------------------------------
	//	foCX^Cv擾
	//
	//		Ȃ
	//
	//	߂l	foCX^Cv
	//--------------------------------------------
	D3DDEVTYPE GetDeviceType();

	//--------------------------------------------
	//	foCX̐\擾
	//
	//		Ȃ
	//
	//	߂l	foCX\
	//--------------------------------------------
	D3DCAPS9& GetCaps();

	//--------------------------------------------
	//	tbV[g擾
	//
	//		Ȃ
	//
	//	߂l	tbV[g
	//--------------------------------------------
	UINT RefreshRate();

	//-------------------------------------------------------------------
	//	eNX`tH[}bgfoCXŃT|[gĂ邩mF
	//
	//		Format	eNX`tH[}bg
	//
	//	߂l	true:	g
	//			false:	gȂ
	//-------------------------------------------------------------------
	bool CheckTextureFormat(D3DFORMAT Format);
	
	//--------------------------------------------
	//	foCX̔\͂
	//
	//		out	o̓Xg[
	//
	//	߂l	Ȃ
	//--------------------------------------------
	void ShowDirect3DCaps(std::basic_ostream<TCHAR>& out);

};



#endif // DIRECT3D9_H
