//--------------------------------------------------//
//	|CgXvCgɂp[eBNiqj\
//
//	TvFp[eBNɂĆi≌j̕\s
//
//	쐬ҁFDaiki Terai
//	쐬F2011/01/06
//	CF2011/01/08
//--------------------------------------------------//

#ifndef _POINTSPRITE_H_
#define _POINTSPRITE_H_

#include "object3d.h"
#include "effect.h"
#include "texture.h"

// |CgXvCgNX
class PointSprite : public Object3D
{
	friend class Drawer;
protected:
	typedef struct _PARTICLE_{
		D3DXVECTOR3 pos;		// Wʒu
		float		psize;		// _TCY
		D3DXVECTOR3 dir;		// 
		float		life_time;	// 
		float		start_time;	// Jn
	}PARTICLE,*LPPARTICLE;

	IDirect3DVertexDeclaration9*	m_pVertexDecl;		// _\̐錾
	IDirect3DVertexBuffer9*			m_pVertexBuf;		// _obt@

	unsigned int					m_ParticleNum;		// p[eBN
	float							m_ElapsedTime;		// oߎ
	float							m_ViewportHeight;	// r[|[g
	D3DXVECTOR3						m_Accel;			// x

	// _\̐錾쐬
	bool CreateVertexDeclaration(IDirect3DDevice9* pD3DDevice);
	// _obt@쐬
	bool CreateVertexBuffer(IDirect3DDevice9* pD3DDevice,int ParticleNum);
	// p[eBÑZbg
	virtual void SetParticle(LPPARTICLE v,int ParticleNum) = 0;
	// obt@쐬
	bool CreateBuffer(IDirect3DDevice9* pD3DDevice,int ParticleNum);
	// sXV
	void Update(IDirect3DDevice9* pD3DDevice);
	// obt@Zbg
	bool SetBuffer(IDirect3DDevice9* pD3DDevice);
	// `
	bool Draw(IDirect3DDevice9* pD3DDevice);

public:
		
	// RXgN^
	PointSprite();
	// fXgN^
	virtual ~PointSprite();

	// 쐬
	bool Create(IDirect3DDevice9* pD3DDevice,int ParticleNum);
	
	//----------------------------------------------------------------------------//
    //	|Cgv~eBu̍őTCY擾
	//	1.0f ɐݒ肳ĂꍇÃfoCXł̓|CgTCY𐧌ł܂
	//	̒l͈̔͂ 1.0f ȏł 
	//----------------------------------------------------------------------------//
	static float GetMaxPointSize(IDirect3DDevice9* pD3DDevice);

	// x̃Zbg
	void SetAccel(const D3DXVECTOR3& Accel);
	// oߎԃZbg
	void ResetTime();
	// oߎԍXV
	void AdvanceTime(float DeltaTime);
	// oߎԎ擾
	float GetTime();
};


#endif //_POINTSPRITE_H_