//-----------------------------------------------//
//	eNX`NX
//
//	쐬ҁFDaiki Terai
//	쐬F2010/08/05
//	CF
//-----------------------------------------------//


#ifndef _TEXTURE_H_
#define _TEXTURE_H_


#include "direct3d9.h"


// `peNX`
class Texture
{
protected:
	// `peNX`
	IDirect3DTexture9* m_pTex;
	// eNX`T[tFCX
	IDirect3DSurface9* m_pSurf;
	// [xobt@T[tFCX
	IDirect3DSurface9* m_pDepthStencilSurf;
	// VXeT[tFX(_[eNX`ȊOsv)
	IDirect3DSurface9* m_pSystemSurf;
	// 
	int m_TexWidth;
	// 
	int m_TexHeight;
	// eNX`
	D3DLOCKED_RECT m_TexRect;

	// T[tFCX擾
	void GetSurfaceInfo(D3DSURFACE_DESC* pOutSurfaceInfo);
public:

	// RXgN^
	Texture();
	// Rs[RXgN^
	Texture(const Texture& obj);
	// =Zq̃I[o[[h
	Texture& operator=(const Texture& obj);
	// Rs[(narrow copy)
	bool Copy(const Texture* pTex);
	// fXgN^
	virtual ~Texture();

	// eNX`쐬
	bool Create(IDirect3DDevice9* pD3DDevice,int Width,int Height,bool isRenderTarget = true,D3DFORMAT Format = D3DFMT_A8R8G8B8);
	// eNX`쐬it@Cǂݍ݁j
	bool Create(const TCHAR* FileName,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey = 0x00000000,D3DFORMAT Format = D3DFMT_A8R8G8B8);
	bool Create(const TCHAR* FileName,IDirect3DDevice9* pD3DDevice);
	// eNX`쐬iǂݍ݁j
	bool Create(const BYTE* pData,DWORD DataSize,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey = 0x00000000,D3DFORMAT Format = D3DFMT_A8R8G8B8);
	bool Create(const BYTE* pData,DWORD DataSize,IDirect3DDevice9* pD3DDevice);
	// eNX`쐬i\[Xǂݍ݁j
	bool Create(int ResourceID,IDirect3DDevice9* pD3DDevice,int Width,int Height,DWORD ColorKey = 0x00000000,D3DFORMAT Format = D3DFMT_A8R8G8B8);
	bool Create(int ResourceID,IDirect3DDevice9* pD3DDevice);

	// eNX`ۑiBMPt@Cój
	bool Save(const TCHAR* FileName);

	// eNX`擾
	IDirect3DTexture9* GetTexture();
	// T[tFX擾
	IDirect3DSurface9* GetSurface();
	// [xobt@T[tFX擾
	IDirect3DSurface9* GetDepthStencilSurface();
	// 擾
	int	GetWidth();
	// 擾
	int GetHeight();
	
	// eNX`bN
	D3DLOCKED_RECT* Lock();
	// eNX`AbN
	void UnLock();

	// _[eNX`bN
	// _[^[Qbgp̃eNX`̓bNłȂ̂
	// rfIVXeɃT[tFCXRs[
	D3DLOCKED_RECT* RenderTextureLock(IDirect3DDevice9* pD3DDevice);

	// _[eNX`AbN
	// foCXnƂ̓T[tFCXXV܂
	void RenderTextureUnLock(IDirect3DDevice9* pD3DDevice = NULL);

};

#endif