//-------------------------------------//
//	RIuWFNgNX
//
//	TvF	RIuWFNgȂ
//			̃NXp邱
//			
//	쐬ҁFDaiki Terai
//	쐬G2010/08/05
//	C
//-------------------------------------//

#ifndef _OBJECT3D_H_
#define _OBJECT3D_H_

#include "direct3d9.h"

// RIuWFNgNX
class Object3D
{
protected:
	// IuWFNg̐ʕiĂj
	D3DXVECTOR3 m_Dir;
	// XP[Asړ
	D3DXVECTOR3 m_Scale,m_Translate;
	// ]s
	D3DXMATRIX	m_RotateMtx;
	// [hϊs
	D3DXMATRIX	m_WorldMtx;
	// r[ϊs
	static D3DXMATRIX m_ViewMtx;
	// ˉeϊs
	static D3DXMATRIX m_ProjMtx;
public:

	//-------------------------//
	// RXgN^
	//-------------------------//
	Object3D();
	//-------------------------//
	// fXgN^
	//-------------------------//
	virtual ~Object3D();

	//-------------------------------------------//
	//	[hϊsZbg
	//
	//	F	WorldMtx	[hϊs
	//-------------------------------------------//
	void SetWorldMatrix(const D3DXMATRIX& WorldMtx);
	//--------------------------------------------//
	//	[hϊs擾
	//
	//	߂lF[hϊs
	//--------------------------------------------//
	const D3DXMATRIX& GetWorldMatrix() const;
	//--------------------------------------------//
	//	[hϊs쐬
	//--------------------------------------------//
	virtual void CreateWorldMatrix();

	//-------------------------------------------//
	//	r[ϊsZbg
	//
	//	FViewMtx r[ϊs
	//-------------------------------------------//
	static void SetViewMtx(const D3DXMATRIX& ViewMtx);
	//--------------------------------------------//
	//	r[ϊs擾
	//
	//	߂lFr[ϊs
	//--------------------------------------------//
	static const D3DXMATRIX& GetViewMatrix();

	//-------------------------------------------//
	//	ˉeϊsZbg
	//
	//	FProjMtx ˉeϊs
	//-------------------------------------------//
	static void SetProjMtx(const D3DXMATRIX& ProjMtx);
	//--------------------------------------------//
	//	ˉeϊs擾
	//
	//	߂lFˉeϊs
	//--------------------------------------------//
	static const D3DXMATRIX& GetProjMatrix();
	
//////////////////////////////////////////////////////////////////

	//-----------------------------------//
	//	XP[OZbg
	//
	//	FScale	XP[O
	//-----------------------------------//
	void SetScale(const D3DXVECTOR3& Scale);
	//-----------------------------------//
	//	XP[OZbg
	//
	//	Fx,y,z	eɑ΂XP[O
	//-----------------------------------//
	void SetScale(float x,float y,float z);
	//-----------------------------------//
	//	]Zbg
	//
	//	FRotate ]
	//-----------------------------------//
	void SetRotate(const D3DXVECTOR3& Rotate);
	//-----------------------------------//
	//	]Zbg
	//
	//	Fx,y,z	eɑ΂]
	//-----------------------------------//
	void SetRotate(float x,float y,float z);
	//-----------------------------------//
	//	sړZbg
	//
	//	FTranslate sړ
	//-----------------------------------//
	void SetTranslate(const D3DXVECTOR3& Translate);
	//-----------------------------------//
	//	sړZbg
	//
	//	Fx,y,z	eɑ΂镽sړ
	//-----------------------------------//
	void SetTranslate(float x,float y,float z);

//////////////////////////////////////////////////////////////////

	//-----------------------------------//
	//	XP[OXV
	//
	//	FScale	XP[O
	//-----------------------------------//
	void UpdateScale(const D3DXVECTOR3& Scale);
	//-----------------------------------//
	//	XP[OXV
	//
	//	Fx,y,z	eɑ΂XP[O
	//-----------------------------------//
	void UpdateScale(float x,float y,float z);
	//-----------------------------------//
	//	]XV
	//
	//	FRotate ]
	//-----------------------------------//
	void UpdateRotate(const D3DXVECTOR3& Rotate);
	//-----------------------------------//
	//	]XV
	//
	//	Fx,y,z	eɑ΂]
	//-----------------------------------//
	void UpdateRotate(float x,float y,float z);
	//-----------------------------------//
	//	sړXV
	//
	//	FTranslate sړ
	//-----------------------------------//
	void UpdateTranslate(const D3DXVECTOR3& Translate);
	//-----------------------------------//
	//	sړXV
	//
	//	Fx,y,z	eɑ΂镽sړ
	//-----------------------------------//
	void UpdateTranslate(float x,float y,float z);

//////////////////////////////////////////////////////////////////

	//-----------------------------------//
	//	XP[O擾
	//
	//	߂lFXP[O
	//-----------------------------------//
	const D3DXVECTOR3& GetScale() const;
	//-----------------------------------//
	//	]擾
	//
	//	߂lF]s
	//-----------------------------------//
	const D3DXMATRIX& GetRotateMatrix() const;
	//-----------------------------------//
	//	sړ擾
	//
	//	߂lFsړ
	//-----------------------------------//
	const D3DXVECTOR3& GetTranslate() const;

//////////////////////////////////////////////////////////////////

	//--------------------------------------------//
	//	f̐ʌZbg
	//
	//	FDir ʌ
	//--------------------------------------------//
	void SetDir(const D3DXVECTOR3& Dir);

	//--------------------------------------------//
	//	f̐ʌ擾
	//
	//	߂lFʌ
	//--------------------------------------------//
	D3DXVECTOR3 GetDir();

};

#endif // _OBJECT3D_H_