//-----------------------------------------------//
//	|SNX
//
//	쐬ҁFDaiki Terai
//	쐬F2011/07/23
//	CF
//-----------------------------------------------//

#ifndef _PLANEPOLYGON_H_
#define _PLANEPOLYGON_H_

#include "direct3d9.h"
#include <map>
#include <vector>

// |S
class PlanePolygon
{
	friend class Drawer;
protected:
	typedef struct _SPRITE_{
		float x,y,z;		// Wʒu
		float u,v;			// UVʒu
	}SPRITE,*LPSPRITE;

	static const unsigned int		VERTEXNUM		= 4;	// _
	static const unsigned short		PRIMITIVENUM	= 2;	// ʐ

	IDirect3DVertexDeclaration9*	m_pVertexDecl;	// _\̐錾
	IDirect3DVertexBuffer9*			m_pVertexBuf;	// _obt@
	IDirect3DIndexBuffer9*			m_pIndexBuf;	// CfbNXobt@

	D3DXMATRIX						m_WorldMtx;		// [hϊs
	D3DXMATRIX						m_ToScreenMtx;	// XN[ϊs
	D3DXMATRIX						m_UVMtx;		// UV؂s
	int								m_DivU;			// U
	int								m_DivV;			// V
	int								m_OffsetU;		// UItZbg
	int								m_OffsetV;		// VItZbg
	int								m_AnimationNum;	// ݂̃Aj[Vԍ
	std::basic_string<TCHAR>		m_AnimationName;// ݂̃Aj[V
	std::map<std::basic_string<TCHAR>,std::vector<int> > m_Animation;	// UVAj[V

	// _\̐錾쐬
	bool CreateVertexDeclaration(IDirect3DDevice9* pD3DDevice);
	// _obt@쐬
	bool CreateVertexBuffer(IDirect3DDevice9* pD3DDevice,int Width,int Height);
	// CfbNXobt@쐬
	bool CreateIndexBuffer(IDirect3DDevice9* pD3DDevice);
	// obt@쐬
	bool CreateBuffer(IDirect3DDevice9* pD3DDevice);
	// s̍XV
	virtual void Update(IDirect3DDevice9* pD3DDevice) = 0;
	// obt@Zbg
	bool SetBuffer(IDirect3DDevice9* pD3DDevice);
	// `
	bool Draw(IDirect3DDevice9* pD3DDevice);

	// UV؂s쐬
	void CreateUVMatrix();
	
public:
		
	// RXgN^
	PlanePolygon();
	// fXgN^
	virtual ~PlanePolygon();
	
	// w
	void SetDivideUV(int DivU,int DivV);
	// UVR}w
	void SetUV(int OffsetU,int OffsetV);
	// UVAj[Vǉ
	bool AddAnimationUV(std::basic_string<TCHAR> AnimationName,int Offset,int FrameCount = 1);
	// UVAj[Vǉ
	bool AddAnimationUV(std::basic_string<TCHAR> AnimationName,int OffsetU,int OffsetV,int FrameCount = 1);
	// UVAj[VZbg
	bool SetAnimation(std::basic_string<TCHAR> AnimationName);
	// ݂UVAj[V̎擾
	std::basic_string<TCHAR>& GetAnimationName();
	// UVAj[VXV
	void UpdateAnimation();
};


#endif
