//-------------------------------------------//
//	EBhENX
//-------------------------------------------//

#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <map>

// VvȃEBhENX
#define WC_BASIC _T("BASIC_WINDOW")


class Window
{
private:
    HWND							m_hWnd;		// EBhEnh
    WNDPROC							m_DefProc;	// ftHgEBhEvV[W
    static	Window*					m_pThis;	// ꎞۑCX^X|C^
    static	std::map<HWND,Window*>	m_Windows;	// Idlep

    // EBhENXo^
    static bool RegistWindow();

    // ÓItB[hĂяoix̂݌Ăяoj
    static Window* StaticField();
public:
    // RXgN^
    Window();
    // fXgN^
    virtual ~Window();



    //--------------------------------------------------------------------//
    //	EBhE쐬
    //
    //	F		Title		^Cg
    //				Width		
    //				Height		
    //				X			XW
    //				Y			YW
    //				ClassName	EBhENX
    //				hParentWnd	eEBhEnh
    //				Style		EBhEX^C
    //				ExStyle		EBhEgX^C
    //				hMenu		j[nh̓\[XID
    //
    //	߂lF	true:	쐬
    //				false:	쐬s
    //--------------------------------------------------------------------//
    virtual bool CreateWnd(
        const TCHAR* Title,int Width = CW_USEDEFAULT,int Height = CW_USEDEFAULT,int X = CW_USEDEFAULT,int Y = CW_USEDEFAULT,
        const TCHAR* ClassName = WC_BASIC,HWND hParentWnd = NULL,DWORD Style = WS_OVERLAPPEDWINDOW,DWORD ExStyle = 0,HMENU hMenu = NULL);

    //--------------------------//
    //	EBhEnh擾
    //
    //	߂lFEBhEnh
    //--------------------------//
    HWND GetWndHandle();

    //-----------------------------------------------------------------------------//
    //	bZ[W[v
    //-----------------------------------------------------------------------------//
    static void MessageLoop();

private:
    //-----------------------------------------------------//
    //  EBhEvV[W̊Ǘ
    //
    //	F	hWnd	EBhEnh
    //			msg		bZ[W
    //			wParam	p[^
    //			lParam	p[^
    //
    //	߂lF
    //-----------------------------------------------------//
    static LRESULT CALLBACK WndProcManager(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);

protected:
    //-----------------------------------------------------//
    //	EBhEvV[W
    //	ftHg̏DefWindowProc֐ōs
    //
    //	F	hWnd	EBhEnh
    //			msg		bZ[W
    //			wParam	p[^
    //			lParam	p[^
    //
    //	߂lF
    //-----------------------------------------------------//
    virtual LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

    //------------------------------------------------------//
    //	EBhE쐬bZ[W
    //
    //	F	hWnd			EBhEnh
    //			lpCreateStruct	EBhE쐬
    //------------------------------------------------------//
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct);

    //------------------------------------------------------//
    //	EBhEN[YbZ[W
    //
    //	F	hWnd	EBhEnh
    //------------------------------------------------------//
    virtual void OnClose(HWND hWnd);

    //------------------------------------------------------//
    //	EBhEjbZ[W
    //
    //	F	hWnd	EBhEnh
    //------------------------------------------------------//
    virtual void OnDestroy(HWND hWnd);

    //-----------------------------------------------------//
    //	bZ[WĂȂƂɍs
    //	DirectXȂǂ̏͂ōs
    //-----------------------------------------------------//
    virtual void Idle();

};

// AvP[VIbZ[W
void ApplicationEnd();



#endif