//----------------------------------//
//	Tv	Direct3D9foCX̍쐬	//
//									//
//	쐬	Daiki Terai				//
//	쐬	2009/12/18				//
//	C						//
//----------------------------------//

#include "direct3d9.h"



//--------------------------------------------
//	RXgN^
//--------------------------------------------
Direct3D9::Direct3D9():
m_D3D9(NULL),m_pDevice3D(NULL),m_DeviceType(D3DDEVTYPE_HAL),m_pBackBufferSurface(NULL),m_pBackBufferDepthStencilSurface(NULL)
{
	memset(&m_D3DParam,0,sizeof(D3DPRESENT_PARAMETERS));
	memset(&m_Display,0,sizeof(D3DDISPLAYMODE));
	memset(&m_D3DCaps,0,sizeof(D3DCAPS9));
	memset(&m_ViewPort,0,sizeof(D3DVIEWPORT9));
}

//--------------------------------------------
//	fXgN^
//--------------------------------------------
Direct3D9::~Direct3D9(){
	// obNobt@[xobt@T[tFX̉
	SafeRelease(m_pBackBufferDepthStencilSurface);
	// obNobt@T[tFX̉
	SafeRelease(m_pBackBufferSurface);

	// Direct3D I
	// ԂɂĒm_pDevice3Ďm_D3D9
	SafeRelease(m_pDevice3D);
	SafeRelease(m_D3D9);
}


//--------------------------------------------
//Direct3D
//
//@	hWnd		EBhEnh
//			Width		
//			Height		
//			bWindowMode	EBhE[hۂ
//			bInterval	fBXvC̓邩ۂ
//
//߂l	true	
//			false	s@
//--------------------------------------------
bool Direct3D9::Create(HWND hWnd,int Width,int Height,bool bWindowMode,bool bInterval)
{
	// 쐬ς݂ł΁AĂэKv͂Ȃ
	if(m_pDevice3D)
		return true;

	/*---------------------------------------------------------------------------*
	Direct3D̏
	*---------------------------------------------------------------------------*/

	// Direct3D9IuWFNg̍쐬	
	m_D3D9 = Direct3DCreate9(D3D_SDK_VERSION);
	if (m_D3D9 == NULL)
		return false;

	// 쐬p[^̐ݒ
	memset(&m_D3DParam, 0, sizeof(D3DPRESENT_PARAMETERS));

	// fBXvC擾
	m_D3D9->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &m_Display);

	if (bWindowMode)
	{
		// EBhEԂŋN
		m_D3DParam.BackBufferFormat				= m_Display.Format;
		m_D3DParam.FullScreen_RefreshRateInHz	= 0;
	}
	else
	{
		// tXN[ԂŋNꍇ̐ݒ
		m_D3DParam.BackBufferFormat				= m_Display.Format;		
		m_D3DParam.FullScreen_RefreshRateInHz	= D3DPRESENT_RATE_DEFAULT;
	}

	// ȉʐݒ
	m_D3DParam.Windowed					= bWindowMode;
	m_D3DParam.BackBufferWidth			= Width;							//obNobt@
	m_D3DParam.BackBufferHeight			= Height;							//obNobt@
	m_D3DParam.SwapEffect				= D3DSWAPEFFECT_DISCARD;
	m_D3DParam.BackBufferCount			= 1;
	m_D3DParam.EnableAutoDepthStencil	= TRUE;
	m_D3DParam.AutoDepthStencilFormat	= D3DFMT_D24S8;						//[xobt@
	m_D3DParam.MultiSampleType			= D3DMULTISAMPLE_NONE;
	m_D3DParam.hDeviceWindow			= hWnd;								//EBhẼnh
	m_D3DParam.Flags					= 0;
	m_D3DParam.PresentationInterval		= bInterval == true ? 
		D3DPRESENT_INTERVAL_DEFAULT			// ŊǗiDon't wait VSYNCj
		: D3DPRESENT_INTERVAL_IMMEDIATE;	// fBXvC̐҂ wait VSYNC


#ifdef _DEBUG
	// A_v^ƃfoCX^Cv
	UINT adapterToUse = D3DADAPTER_DEFAULT;
	m_DeviceType = D3DDEVTYPE_HAL;
	
	// 'NVIDIA PerfHUD'A_v^TĂ΃A_v^ɒu
	for (UINT adapter = 0; adapter < m_D3D9->GetAdapterCount(); adapter++) {
		D3DADAPTER_IDENTIFIER9 identifier;
		HRESULT res = m_D3D9->GetAdapterIdentifier( adapter, 0, &identifier);
		if (strstr(identifier.Description, "PerfHUD") != 0) {
			adapterToUse = adapter;
			m_DeviceType = D3DDEVTYPE_REF;
			break;
		}
	}

	// PerfHUDŃfoCX쐬iREF[hI[j
	if(adapterToUse != D3DADAPTER_DEFAULT){
		if(FAILED(m_D3D9->CreateDevice(adapterToUse, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
			m_D3D9->CreateDevice(adapterToUse, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D);
	}

#endif

	if(m_pDevice3D == NULL)
	{
		// rfIJ[h̐\擾
		// \̗ǂɎFHAL[hn[hEFAAREF[h\tgEFAԏASW[hzIȃfoCX\z
		m_D3D9->GetDeviceCaps(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, &m_D3DCaps);
		m_DeviceType = D3DDEVTYPE_HAL;

		// HAL
		//if (FAILED(m_D3D9->CreateDevice(D3DADAPTER_DEFAULT,m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
		if (FAILED(m_D3D9->CreateDevice(D3DADAPTER_DEFAULT, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_MIXED_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
		{
			// rfIJ[h̐\擾
			// \̗ǂɎFHAL[hn[hEFAAREF[h\tgEFAԏASW[hzIȃfoCX\z
			m_D3D9->GetDeviceCaps(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, &m_D3DCaps);
			m_DeviceType = D3DDEVTYPE_REF;

			// REF
			if (FAILED(m_D3D9->CreateDevice(D3DADAPTER_DEFAULT, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
			if (FAILED(m_D3D9->CreateDevice(D3DADAPTER_DEFAULT, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
			{

					// rfIJ[h̐\擾
					// \̗ǂɎFHAL[hn[hEFAAREF[h\tgEFAԏASW[hzIȃfoCX\z
					m_D3D9->GetDeviceCaps(D3DADAPTER_DEFAULT, D3DDEVTYPE_SW, &m_D3DCaps);
					m_DeviceType = D3DDEVTYPE_SW;

					// SW
					if (FAILED(m_D3D9->CreateDevice(D3DADAPTER_DEFAULT, m_DeviceType, m_D3DParam.hDeviceWindow, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DParam, &m_pDevice3D)))
					{
						MessageBox(NULL,_T("DirectXg܂AOtBbN{[h𔃂ւĂ"),NULL,MB_ICONEXCLAMATION);
						// SɎs
						return false;
					}
			}
		}
	}



	// JOv
	m_pDevice3D->SetRenderState(D3DRS_CULLMODE,D3DCULL_CCW);
	// NbsOI
	m_pDevice3D->SetRenderState(D3DRS_CLIPPING,TRUE);
	// XeVobt@I
	m_pDevice3D->SetRenderState(D3DRS_STENCILENABLE,TRUE);
	// Zobt@̏ݐݒI
	m_pDevice3D->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	// Zobt@I
	m_pDevice3D->SetRenderState(D3DRS_ZENABLE,D3DZB_TRUE);
	// CeBOI
	m_pDevice3D->SetRenderState(D3DRS_LIGHTING,TRUE);


	// obNobt@T[tFCX擾
	m_pDevice3D->GetRenderTarget(0,&m_pBackBufferSurface);
	// [xobt@T[tFCX擾
	m_pDevice3D->GetDepthStencilSurface(&m_pBackBufferDepthStencilSurface);
	// r[|[g擾
	m_pDevice3D->GetViewport(&m_ViewPort);

	// I
	//atexit(Direct3D9::Release);


	return true;
}			



//--------------------------------------------
//	obNobt@T[tFCX̎擾
//
//		Ȃ
//
//	߂l	obNobt@T[tFCX
//--------------------------------------------
IDirect3DSurface9* Direct3D9::GetBackBufferSurface()
{
	return m_pBackBufferSurface;
}
//--------------------------------------------
//	obNobt@[xobt@T[tFCX̎擾
//
//		Ȃ
//
//	߂l	obNobt@[xobt@T[tFCX
//--------------------------------------------
IDirect3DSurface9* Direct3D9::GetBackBufferDepthStencilSurface()
{
	return m_pBackBufferDepthStencilSurface;
}
//--------------------------------------------
//	Xbv`FCݒ擾
//
//		Ȃ
//
//	߂l	Xbv`FCݒ
//--------------------------------------------
D3DPRESENT_PARAMETERS* Direct3D9::GetPresentParam()
{
	return &m_D3DParam;
}
//--------------------------------------------
//	r[|[g̎擾
//
//		Ȃ
//
//	߂l	r[|[g
//--------------------------------------------
D3DVIEWPORT9* Direct3D9::GetViewPort()
{
	return &m_ViewPort;
}


//--------------------------------------------
//	foCX̎擾
//
//		Ȃ
//	
//	߂l	direct3DfoCX
//--------------------------------------------
IDirect3DDevice9* Direct3D9::GetDevice()
{
	return m_pDevice3D;
}

//----------------------------------
//	(_[^[Qbg)NA
//
//			NAF
//
//	߂l	true	
//			false	s
//----------------------------------
bool Direct3D9::ScreenClear(DWORD Color)
{
	if(FAILED(m_pDevice3D->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_STENCIL | D3DCLEAR_ZBUFFER, Color, 1.0f, 0 )))
		return false;

	return true;
}

//----------------------------------
//	`Jn
//
//	߂l	true	
//			false	s
//----------------------------------
bool Direct3D9::BeginScene(){
	if(FAILED(m_pDevice3D->BeginScene()))
		return false;

	return true;
}

//----------------------------------
//	`I
//
//	߂l	true	
//			false	s
//----------------------------------
bool Direct3D9::EndScene()
{
	if(FAILED(m_pDevice3D->EndScene()))
		return false;

	return true;
}

//----------------------------------
//	Xbv`FC\ʂɏo
//
//	߂l	true	
//			false	s
//----------------------------------
bool Direct3D9::Present(){

	if(FAILED(m_pDevice3D->Present( NULL, NULL, NULL, NULL )))
		return false;

	return true;
}

//--------------------------------------------
//	foCX^Cv擾
//
//		Ȃ
//
//	߂l	foCX^Cv
//--------------------------------------------
D3DDEVTYPE Direct3D9::GetDeviceType(){
	return m_DeviceType;
}

//--------------------------------------------
//	foCX̐\擾
//
//		Ȃ
//
//	߂l	foCX\
//--------------------------------------------
D3DCAPS9& Direct3D9::GetCaps(){
	return m_D3DCaps;
}

//--------------------------------------------
//	tbV[g擾
//
//		Ȃ
//
//	߂l	tbV[g
//--------------------------------------------
UINT Direct3D9::RefreshRate(){
	return m_Display.RefreshRate;
}

//-------------------------------------------------------------------
//	eNX`tH[}bgfoCXŃT|[gĂ邩mF
//
//		Format	eNX`tH[}bg
//
//	߂l	true:	g
//			false:	gȂ
//-------------------------------------------------------------------
bool Direct3D9::CheckTextureFormat(D3DFORMAT Format){


	if(FAILED(m_D3D9->CheckDeviceFormat(
		D3DADAPTER_DEFAULT,
		D3DDEVTYPE_HAL,
		m_Display.Format,
		0,
		D3DRTYPE_TEXTURE,
		Format)))
		return false;

	return true;
}


//--------------------------------------------
//	foCX̔\͂
//
//		out	o̓Xg[
//
//	߂l	Ȃ
//--------------------------------------------
void Direct3D9::ShowDirect3DCaps(std::basic_ostream<TCHAR>& out)
{
	D3DCAPS9 caps;
	m_pDevice3D->GetDeviceCaps(&caps);

	// foCX^Cv
	switch(m_DeviceType){
	case D3DDEVTYPE_HAL:
		out << _T("D3DDEVTYPE_HAL") << std::endl;
		break;
	case D3DDEVTYPE_REF:
		out << _T("D3DDEVTYPE_REF") << std::endl;
		break;
	case D3DDEVTYPE_SW:
		out << _T("D3DDEVTYPE_SW") << std::endl;
		break;
	}

	// _VF[_o[W擾
	DWORD VertexShaderVer = caps.VertexShaderVersion;
	// sNZVF[_o[W擾
	DWORD PixelShaderVer = caps.PixelShaderVersion;

	// gpł钸_VF[_̃o[W
	if(VertexShaderVer >= D3DVS_VERSION(3,0))
		out << _T("VertexShader") << _T("\t\t") << _T("Ver 3_0") << std::endl;
	else if(VertexShaderVer >= D3DVS_VERSION(2,0))
		out << _T("VertexShader") << _T("\t\t") << _T("Ver 2_0") << std::endl;
	else if(VertexShaderVer >= D3DVS_VERSION(1,1))
		out << _T("VertexShader") << _T("\t\t") << _T("Ver 1_1") << std::endl;
	else
		out << _T("_VF[_g܂") << std::endl;

	// gpłsNZVF[_̃o[W
	if(PixelShaderVer >= D3DVS_VERSION(3,0))
		out << _T("PixelShader") << _T("\t\t") << _T("Ver 3_0") << std::endl;
	else if(PixelShaderVer >= D3DVS_VERSION(2,0))
		out << _T("PixelShader") << _T("\t\t") << _T("Ver 2_0") << std::endl;
	else if(PixelShaderVer >= D3DVS_VERSION(1,1))
		out << _T("PixelShader") << _T("\t\t") << _T("Ver 1_1") << std::endl;
	else
		out << _T("sNZVF[_g܂") << std::endl;


	// xɃufBOłs̍ő吔
	out << _T("MaxVertexBlendMatrices") << _T("\t") << caps.MaxVertexBlendMatrices << std::endl;

	// Ɏgpł郌_O^[Qbg̐
	out << _T("MultiRenderTargetNum") << _T("\t")  << caps.NumSimultaneousRTs << std::endl;

	// gpłXg[̐
	out << _T("MaxStream") << _T("\t\t") << caps.MaxStreams << std::endl;

}