#include "window.h"
#include "direct3d9.h"
#include "fps.h"
#include "debugtext.h"

class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	FPS			m_FPS;
	DebugText	m_Text;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		
		// fobNtHg쐬
		m_Text.CreateDXFont(m_Direct3D9.GetDevice(),24);


		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){
		m_Direct3D9.ScreenClear(0xff0000ff);
		if(m_Direct3D9.BeginScene()){

			// eLXg`
			m_Text.Draw(0xffffffff,0,0,_T("FPS = %.1lf"),m_FPS.GetFPS());
			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}