#ifndef _UNICODE_H_
#define _UNICODE_H_

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <stdarg.h>

// UnicodeA}`oCgɑΉ邽߂TCHAR^߂ł
// _T("")}Nň͂ĂTCHARƂĈ܂

/*

// TCHAR^string
std::basic_string<TCHAR>		

// TCHAR^stream
std::basic_ostream<TCHAR>		// Wo̓Xg[
std::basic_istream<TCHAR>		// W̓Xg[
std::basic_ostringstream<TCHAR> // o̓Xg[i`i[pobt@j
std::basic_istringstream<TCHAR> // ̓Xg[i`擾pobt@j
std::basic_ifstream<TCHAR>		// t@C̓Xg[
std::basic_ofstream<TCHAR>		// t@Co̓Xg[
std::basic_fstream<TCHAR>		// t@CXg[


#ifdef UNICODE
std::wcin	// 
std::wcout	// o
std::wcerr	// G[
std::wclog	// O
#else
std::cin	// 
std::cout	// o
std::cerr	// G[
std::clog	// O
#endif

*/

// [Ή\]				TCHAR		MULTIBYTE	UNICODE
// Wo				_tprintf	,printf		,wprintf
// obt@ɐ`o		_stprintf	,sprintf	,swprintf
// r			_tcscmp		,strcmp		,lstrcmp
// g[N			_tcstok		,strtok		,wcstok
// 񐮐ϊ		_tstoi		,atoi		,_wtoi
// 񏬐ϊ		_tstof		,atof		,_wtof
// A			_tcscat		,strcat		,wcscat
// Rs[			_tcscpy		,strcpy		,wcscpy
// 				_tcslen		,strlen		,wcslen
// ϊ			_totlower	,tolower	,towlower
// tpX				_tfullpath	,_fullpath	,_wfullpath

// Unicode}`oCgϊ wcstombs
// }`oCgUnicodeϊ mbstowcs


// u֐(WȂ̂ō܂)
// T:^ichar,wchar_tj
// source		Ώە
// pattern		uΏۃp^[
// placement	u
template <class T>
std::basic_string<T> treplace (
    const std::basic_string<T>& source,
    const std::basic_string<T>& pattern,
    const std::basic_string<T>& placement
	)
{
    std::basic_string<T> result;
    std::basic_string<T>::size_type pos_before = 0;
    std::basic_string<T>::size_type pos = 0;
    std::basic_string<T>::size_type len = pattern.size();
	while ((pos = source.find(pattern, pos)) != std::basic_string<TCHAR>::npos) {
        result.append(source, pos_before, pos - pos_before);
        result.append(placement);
        pos += len;
        pos_before = pos;
    }
    result.append(source, pos_before, source.size() - pos_before);
    return result;

}

// tԂ
// T:^ichar,wchar_tj
template <class T>
std::basic_string<T> tformat(const T* format, ...)
{
	std::basic_string<T> Str;
	va_list va;
	va_start(va, format);
	T* Buf = new T[_vsctprintf(format,va) + 1];
	if(_vstprintf(Buf,format, va) < 0){
		// G[
		delete[] Buf;
		return Str;
	}
	Str.append(Buf);
	va_end(va);
	delete[] Buf;

	return Str;
}



#endif	// _UNICODE_H_