#include "drawer.h"

Effect Drawer::m_PointSpriteEffect;

// GtFNgǂݍ
bool Drawer::LoadEffect(IDirect3DDevice9* pD3DDevice)
{
	// 􉽃IuWFNg
	Geometory::Init(pD3DDevice);

	if(!m_PointSpriteEffect.Create(pD3DDevice,_T("pointsprite.cfx")))
		return false;

	return true;
}


// |CgXvCg`
bool Drawer::DrawPointSprite(PointSprite& pointsprite,Texture& texture)
{
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_PointSpriteEffect.GetEffect()->GetDevice(&pD3DDevice);

	// |CgXvCgsXV
	pointsprite.Update(pD3DDevice);

	// [hϊs̃Zbg
	m_PointSpriteEffect.SetMatrix(_T("g_mWorld"),&pointsprite.m_WorldMtx);
	// r[ϊs̃Zbg
	m_PointSpriteEffect.SetMatrix(_T("g_mView"),&Object3D::m_ViewMtx);
	// ˉeϊs̃Zbg
	m_PointSpriteEffect.SetMatrix(_T("g_mProj"),&Object3D::m_ProjMtx);
	// r[|[g̍ZbgisɂTCYj
	m_PointSpriteEffect.SetFloat(_T("g_ViewportHeight"),pointsprite.m_ViewportHeight);
	// ݎ̐ݒ	
	m_PointSpriteEffect.SetFloat(_T("g_Time"),pointsprite.m_ElapsedTime);
	// x̐ݒ	
	m_PointSpriteEffect.SetVector3(_T("g_Accel"),&pointsprite.m_Accel);
	// eNX`
	m_PointSpriteEffect.SetTexture(_T("g_Texture"),texture.GetTexture());

	// eNjbÑZbg
	m_PointSpriteEffect.SetTechnique(_T("T0"));
	// GtFNgJn
	m_PointSpriteEffect.Begin();

	// `
	if(!pointsprite.Draw(pD3DDevice))
		return false;

	// GtFNgI
	m_PointSpriteEffect.End();

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}
