#include "rendertarget.h"



//------------------------------------------------------------------------
//	_[^[Qbg̕ύX
//
//	F	texture		_[^[QbgeNX`
//			targetNum	_[^[Qbgԍ
//
//	߂lF	true	
//			false	s
//------------------------------------------------------------------------
bool SetRenderTarget(Texture& texture,DWORD targetNum)
{
	IDirect3DDevice9* pD3DDevice = NULL;
	if(texture.GetTexture() == NULL){
		ASSERT_MSG(_T("_[^[QbgpeNX`쐬Ă܂\n"));
		return false;
	}
	texture.GetTexture()->GetDevice(&pD3DDevice);

	if(texture.GetSurface() == NULL || texture.GetDepthStencilSurface() == NULL){
		ASSERT_MSG(_T("_[^[QbgpT[tFCX쐬Ă܂\n"));
		return false;
	}
	// _[^[Qbg̕ύX
	pD3DDevice->SetRenderTarget(targetNum,texture.GetSurface());
	// [xXeVobt@̕ύX
	pD3DDevice->SetDepthStencilSurface(texture.GetDepthStencilSurface());
	// r[|[g̕ύX
	D3DVIEWPORT9 Viewport;
	Viewport.X = 0;
	Viewport.Y = 0;
	Viewport.Width = texture.GetWidth();
	Viewport.Height = texture.GetHeight();
	Viewport.MinZ = 0.0f;
	Viewport.MaxZ = 1.0f;
	pD3DDevice->SetViewport(&Viewport);

	SafeRelease(pD3DDevice);
	return true;
}

//------------------------------------------------------------------------
//	_[^[Qbg̕ύXiftHg̃obNobt@j
//
//	F	direct3d	Direct3D
//			targetNum	_[^[Qbgԍ
//
//	߂lF	true	
//			false	s
//------------------------------------------------------------------------
bool SetRenderTarget(Direct3D9& direct3d,DWORD targetNum)
{
	if(direct3d.GetDevice() == NULL){
		ASSERT_MSG(_T("Direct3DfoCX쐬Ă܂\n"));
		return false;
	}

	// _[^[Qbg̕ύX
	direct3d.GetDevice()->SetRenderTarget(targetNum,direct3d.GetBackBufferSurface());
	// [xXeVobt@̕ύX
	direct3d.GetDevice()->SetDepthStencilSurface(direct3d.GetBackBufferDepthStencilSurface());
	// r[|[gɕύX
	direct3d.GetDevice()->SetViewport(direct3d.GetViewPort());

	return true;
}
