#include "drawer.h"

Effect Drawer::m_PlanePolygonEffect;

// GtFNgǂݍ
bool Drawer::LoadEffect(IDirect3DDevice9* pD3DDevice)
{
	// 􉽃IuWFNg
	Geometory::Init(pD3DDevice);

	if(!m_PlanePolygonEffect.Create(pD3DDevice,_T("planepolygon.cfx")))
		return false;

	return true;
}
// XvCg`ieNX``j
bool Drawer::DrawPlanePolygon(PlanePolygon& planepolygon,Texture& texture)
{
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_PlanePolygonEffect.GetEffect()->GetDevice(&pD3DDevice);

	// |SsXV
	planepolygon.Update(pD3DDevice);

	// [hϊsZbg
	m_PlanePolygonEffect.SetMatrix(_T("g_mWorld"),&planepolygon.m_WorldMtx);
	// tr[|[gϊsZbg
	m_PlanePolygonEffect.SetMatrix(_T("g_mToScreen"),&planepolygon.m_ToScreenMtx);
	// UV؂sZbg
	m_PlanePolygonEffect.SetMatrix(_T("g_mUV"),&planepolygon.m_UVMtx);
	// eNX`Zbg
	m_PlanePolygonEffect.SetTexture(_T("g_Texture1"),texture.GetTexture());
	// ItZbg̃Zbg
	m_PlanePolygonEffect.SetVector4(_T("g_Offset"),&D3DXVECTOR4(1.0f/texture.GetWidth(),1.0f/texture.GetHeight(),0.0f,0.0f));
	
	// eNjbÑZbg
	m_PlanePolygonEffect.SetTechnique(_T("T0"));
	// GtFNgJn
	m_PlanePolygonEffect.Begin();

	// `
	if(!planepolygon.Draw(pD3DDevice))
		return false;

	// GtFNgI
	m_PlanePolygonEffect.End();

	// foCX
	SafeRelease(pD3DDevice);
	return true;
}

