#include "renderstate.h"


// _[Xe[g̕ύX
void SetRenderState(IDirect3DDevice9* pD3DDevice,RENDERSTATE RenderState,unsigned char Alpha){

	switch(RenderState)
	{
	case RENDER_DEFAULT:
		{
			// sIuWFNg
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);		//At@eXg̖
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);		//At@ufBO̖
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );			//Zobt@ւ݂̏LɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );		//ZeXgs		
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, TRUE );				//CeBO
		}
		break;
	case RENDER_ALPHATEST:
		{
			// eXgɂwF
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);			//At@eXg̗L
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,FALSE);			//At@ufBO̖
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );				//Zobt@ւ݂̏LɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );			//ZeXgs		
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, TRUE );					//CeBO

			pD3DDevice->SetRenderState(D3DRS_ALPHAREF, Alpha);					//At@Qƒl
			pD3DDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);	//At@eXgi
		}
		break;
	case RENDER_ALPHABLEND:
		{
			// ufBOɂwiFƂ̍
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);			//At@eXg̖
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);			//At@ufBO̗L
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );			//Zobt@ւ݂̏𖳌ɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );			//ZeXgsȂ			
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, FALSE );				//CeBOȂ

			pD3DDevice->SetRenderState( D3DRS_BLENDOP,   D3DBLENDOP_ADD );		//ufBOIvVZ
			pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);		//SRC̐ݒ
			pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);	//DEST̐ݒ

		}
		break;
	case RENDER_SUB:
		{
			// Z
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);			//At@eXg̖
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);			//At@ufBO̗L
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );			//Zobt@ւ݂̏𖳌ɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );			//ZeXgsȂ			
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, FALSE );				//CeBOȂ
			
			pD3DDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_REVSUBTRACT );//ufBOIvVZ
			pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);		//SRC̐ݒ
			pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);			//DEST̐ݒ
		}
		break;
	case RENDER_HALFADD:
		{
			// Z
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);			//At@eXg̖
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);			//At@ufBO̗L
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );			//Zobt@ւ݂̏𖳌ɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );			//ZeXgsȂ			
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, FALSE );				//CeBOȂ

			pD3DDevice->SetRenderState( D3DRS_BLENDOP,   D3DBLENDOP_ADD );		//ufBOIvVZ
			pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);			//SRC̐ݒ
			pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);	//DEST̐ݒ
		}
		break;
	case RENDER_ADD:
		{
			// SZ
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);		//At@eXg̖
			pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);		//At@ufBO̗L
			pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );		//Zobt@ւ݂̏𖳌ɂB
			pD3DDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );		//ZeXgsȂ			
			pD3DDevice->SetRenderState( D3DRS_LIGHTING, FALSE );			//CeBOȂ

			pD3DDevice->SetRenderState( D3DRS_BLENDOP,   D3DBLENDOP_ADD );	//ufBOIvVZ
			pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);		//SRC̐ݒ
			pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);		//DEST̐ݒ
		}
		break;
	}
}

