#include "renderwindow.h"

// RXgN^
RenderWindow::RenderWindow()
	:m_pDirect3D9(NULL),m_pTex(NULL)
{}
// fXgN^
RenderWindow::~RenderWindow()
{}

// EBhE쐬
bool RenderWindow::Create(Direct3D9* pDirect3D9,Texture* pTex,int Width,int Height,const TCHAR* Title){
	m_pDirect3D9 = pDirect3D9;
	m_pTex = pTex;
	return this->CreateWnd(Title,Width,Height);
}

// EBhE쐬
BOOL RenderWindow::OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct)
{
	
	// Xbv`F[쐬
	m_SwapChain.Create(m_pDirect3D9->GetDevice(),hWnd,
		lpCreateStruct->cx,lpCreateStruct->cy
		,m_pDirect3D9->GetPresentParam());
	
	// XvCg쐬
	m_Sprite.Create(m_pDirect3D9->GetDevice(),lpCreateStruct->cx,lpCreateStruct->cy);
	// XvCgʒu
	m_Sprite.SetPos(lpCreateStruct->cx/2,lpCreateStruct->cy/2);
	return TRUE;
}


// `揈
void RenderWindow::Idle(){

	// `
    if(m_pDirect3D9->BeginScene()){

		// _[^[Qbg̃EBhEp̃Xbv`F[ɐ؂ւ
		SetRenderTarget(m_SwapChain);

		// _[Xe[gʏ`
		SetRenderState(m_pDirect3D9->GetDevice(),RENDER_DEFAULT);
		// Tv[Xe[g
		SetSamplerState(m_pDirect3D9->GetDevice(),SAMPLER_POINT);

		// |S`
		Drawer::DrawPlanePolygon(m_Sprite,*m_pTex);

		// _[^[QbgXbv`F[ɖ߂
		SetRenderTarget(*m_pDirect3D9);
		
		m_pDirect3D9->EndScene();
	}
	// Xbv`F[\ʂɏo
	m_SwapChain.Present();
}
